// commport.cpp
#include "commport.h"
#include <iostream>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
#include <string>
#include <time.h>

#define SERIAL_PORT "/dev/ttyS0"

using namespace std;


int commport::openPort()
  {
    fd = open(SERIAL_PORT, O_RDWR | O_NDELAY);
    if (fd < 0)
      {
	cout << "Unable to open the serial port" << endl;
	cout << "exit ..." << endl;
	exit(-1);
      }   
    return fd;
  }

void commport::initPort( int fd )
  {
    bzero(&newtio, sizeof(newtio));
    newtio.c_cflag = B4800 | CS8 | CREAD | CLOCAL | CSTOPB;
    newtio.c_iflag = IGNPAR;
    newtio.c_oflag = 0;
    newtio.c_lflag = 0;
    newtio.c_cc[VTIME] = 0; /* ignore timer */
    newtio.c_cc[VMIN] = 0; /* no blocking read */
    
    /* Clear RX buffer of any unread data */
    tcflush(fd, TCIFLUSH);
    tcsetattr(fd,TCSANOW,&newtio);
    }

void commport::cmdK2( char * ddd, int fd)
{
  int slen = strlen(ddd);
  write(fd, ddd, slen);
}

int commport::closePort( int fd )
{
  return ( close( fd ));
}


string*  commport::read_K2( int fd )
{
// Clear buffers
  a.tv_sec = 0;
  a.tv_nsec = 10000;
    qbuf = "";
    bzero(buf, 80);
    pqbuf = &qbuf;
// Begin read loop
    while(1==1){
	read(fd, buf, 1);
	int bsize = strlen(buf);
// Check to see if there is data in what was just read
	if(bsize >= 1){ // data detected
	  //cout << "Debug buf[0] = " << buf[0] << endl;
	    if(buf[0] == ';'){ // Check for K2 EOL char 
	      return pqbuf;
	    }
// It is not EOL so save the data just received  and append it to our data buffer
// UhOh something really wierd in here. Delay fixed it.
	    nanosleep( &a, &b );
	    qbuf += buf[0];
	    // cout << "Debug qbuf = " << qbuf << endl;
	}else{
	  qbuf = "none";
	  return pqbuf;
	}
		bzero(buf, 80);  // Make sure temporary read buffer is empty

    }  
}


