/***************************************************************************
                          k2cmdr.cpp  -  description
                             -------------------
    begin                : Sat Aug 9 2003
    copyright            : (C) 2003 by Mike Studer AB6CV
    email                : ab6cv@arrl.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "k2cmdr.h"

#include <iostream>

#include <stdlib.h>
#include <stdio.h>
#include <termios.h>
#include <string.h>

using namespace std;


k2cmdr::k2cmdr(void *arg) : d_arg(arg)
{/* no code needed*/}


void  k2cmdr::set_keypress(){
    struct termios new_settings;
    tcgetattr(0, &stored_settings); // fd = 0 STDIN
    new_settings = stored_settings;
    /* Disable canonical mode, and set buffer size to 1 byte */
    new_settings.c_lflag &= (~ICANON);
    new_settings.c_lflag &= (~ECHO); // No echo
    new_settings.c_cc[VTIME] = 0;
    new_settings.c_cc[VMIN] = 1;
    tcsetattr(0,TCSANOW, &new_settings);
    return;  
}

void k2cmdr::reset_keypress(){
    tcsetattr(0, TCSANOW, &stored_settings);
    return;
}

void* k2cmdr::chk4cmd(){
  ch  = '\0';
  cmd_clear();

while(1==1)
{
 cin >> ch;
 if(ch != '\0')
  {
   ch_value = ch;
//   cout << "Debug = " << dec << ch_value;
//   cout << " Hex = " << hex << ch_value << endl;

 if (ch_value == 27)
 {
   // Possible command sequence
   p1 = ch_value;
 } else
   {
      if (p1 == 27 & p2 == 0)
      {
         p2 = ch_value;
         // check for 2 digit cmd sequences here
         cmd_parse();
      } else
         {
            if( p1 != 0 & p2 != 0)
            {
               p3 = ch_value;
               cmd_parse();
            }
          }
   } 
  } 
 }
}

void k2cmdr::cmd_clear()
{
 p1 = p2 = p3 = 0;
}

void k2cmdr::cmd_parse()
{

//k2stats K2stat(NULL);

if( p1 == 27 & p3 == 0 )
{
   if( p2 == 120 )
      {
         cout << "Program exit" << endl;
         reset_keypress();
         exit(0);                                              
         
      }
}

// 3 digit command sequence tests

// Check for F keys
if( p1 == 27 & p2 == 79 & p3 != 0 )
   {
      cout << "F Key = " << ch_value << endl;
      if(p3 == 80 )
      {
         // F1 key
         vfo_dd();
      }

      
      cmd_clear();
   }

// Check for Arrow key
if( p1 == 27 & p2 == 91 & p3 != 0 )
   {
      cout << "Arrow key = " << ch_value << endl;
      cmd_clear();
   }

}

void* chk4cmd_wrapper(void* This)
{
 return static_cast<k2cmdr*>(This)->chk4cmd();
}

   void* queryrig_wrapper(void* This)
{
 return static_cast<k2cmdr*>(This)->queryrig();
}             
