/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Fri Aug  8 17:46:38 PDT 2003
    copyright            : (C) 2003 by Mike Studer AB6CV
    email                : ab6cv@arrl.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// Command Line Elecraft K2 Rig Control Program
#include "commport.h"
#include "moac.h"
#include <iostream>
#include <string>
#include <string.h>
#include <unistd.h>
#include <curses.h>
#include <pthread.h>

using namespace std;

int main()
{
// Variable defs
  int fdd, status;
  char cmd[30];


  pthread_t thr_k2, thr_user;

  
// Class start up  
  commport K2comm;
  moac K2cmdr(NULL);

// Program start
  cout << endl << "Program Start" << endl;
  fdd = K2comm.openPort();

  K2comm.initPort( fdd );
  cout << "Port initialized" << endl;

  // File Descriptor obtained so share it
  K2cmdr.fd = &fdd;
  
  // Initialize K2
  strcpy(cmd, "AI2;K22;");
  K2comm.cmdK2( cmd, fdd );


  K2cmdr.bootup();
  
  // Read response from the K2
  status = pthread_create(&thr_k2, NULL, queryrig_wrapper, &K2cmdr);
  if(status != 0) {
  cout << "thr_k2 thread create FAILED = " << status << endl;   // DEBUG
  exit(1);
  }
  
 // Check for User inputs
  K2cmdr.set_keypress();    // Set up termio for accepting a single key input
  status = pthread_create(&thr_user, NULL, chk4cmd_wrapper, &K2cmdr);
   if(status != 0) {
      cout << "thr_user thread create FAILED = " << status << endl;   // DEBUG
      exit(1);
   }
// Do the joins AFTER creating the threads.
  pthread_join(thr_k2, NULL);
  pthread_join(thr_user, NULL);

  
   // Exit program ?
  K2cmdr.reset_keypress(); 
  K2comm.closePort( fdd );
  cout << "Port closed, Program terminated." << endl;

}
