/***************************************************************************
                          moac.h  -  description
                             -------------------
    begin                : Wed Sep 17 2003
    copyright            : (C) 2003 by Mike Studer
    email                : ab6cv@arrl.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MOAC_H
#define MOAC_H

#include <termios.h>
#include <iostream>
#include <string>

using namespace std;

/**
  *@author Mike Studer
  */

class moac
{
private:
   struct termios stored_settings;
   char ch;
   int ch_value, tune_step, fil, p1, p2, p3, modenum;
   void* d_arg;
   char CMD[30];
   void cmd( char*, int );
   double akhz_d, bkhz_d;   // VFO A and B frequencies
      
public:
   void* chk4cmd();
   void cmd_parse();
   void cmd_clear();
   void tune_up();
   void tune_down();
   void s_up();
   void s_down();
   void bootup();
   void filters();
   void s_meter();
   void set_keypress();
   void reset_keypress();
   moac(void *arg);
   void cmdparse( string );
   void* queryrig();

   string *rxdata;
   string temp;
   int *fd;
   

string AN; // Antenna Selection
string BG; // Bargraph Read
string FA; // VFO A freq in hz
string FB; // VFO B freq in hz
string FR; // RX VFO 0=A, 1=B
string FT; // TX VFO
string FW; // Filter bandwidth and number
string GT; // AGC time constant
string IF; // Transceiver Information
string KS; // Keyer Speed
string KY; // CW keying from text
string LK; // VFO lock
string MD; // Operating Mode
string NB; // Noise Blanker Mode
string PA; // RX preamp
string PC; // TX pwr
string PS; // Rig power on?
string RA; // RX atten
string RT; // RIT
string SQ; // Squelch level
string XT; // XIT

   void vfo_dd();       // formatted output of frequency data
};

extern "C" void* chk4cmd_wrapper(void*);
extern "C" void* queryrig_wrapper(void*);

#endif
